/**
 * Copyright siouxcitizen ( http://wonderfl.net/user/siouxcitizen )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/9rgx
 */

// forked from hacker_7daxapax's ButtonTest06:　複数問クイズ形式に正答率計算機能を追加 
//最初は「ジョジョの奇妙な冒険」クイズにしようと思ったけど手許に資料(コミックス)がないので、
//Wikipediaでひろいながら徳川将軍クイズにしてみました。
//答えられる質問だけこたえて「次の質問へ」ボタン連射→終了でも解答率が100％になる。。。
//要改善です。。。
package {
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;

    [SWF(width="500", height="500", backgroundColor="#FFFFFF")]
    public class ButtonTest extends Sprite {
        
        private var button01 : SimpleButton;//ボタン1 
        private var button02 : SimpleButton;//ボタン2
        private var button03 : SimpleButton;//ボタン3
        private var nextBtn : SimpleButton;//「次の問題へ」ボタン
                
        private var question : TextField;//問題文テキスト
        private var questionFormat : TextFormat;//問題文テキストフォーマット
        private var judge : TextField;//判定文テキスト
        private var judgeFormat : TextFormat;//判定文テキストフォーマット
        
        private var target : CustomButton;//マウスイベントでターゲット情報取得用
        private var questionNo : int = 0;//問題番号
        private var questionArray : Array = new Array();//問題保持用配列 
        private var answerArray : Array = new Array();//解答保持用配列   

        private var answerCnt : int = 0;//解答回数
        private var atariCnt : int = 0;//当たり回数
        private var hazureCnt : int = 0;//ハズレ回数
        private var atariLock : Boolean = false;//「当たり」ボタン連続押下による当たり回数アップを禁止　「ハズレ」は何回でも可

        public function ButtonTest() {
            questionArray.push("徳川幕府初代将軍は？\n１、徳川家康\n２、織田信長\n３、豊臣秀吉\n");
            answerArray.push(1);
            questionArray.push("徳川幕府2代将軍は？\n１、徳川家康\n２、徳川秀忠\n３、徳川家光\n");
            answerArray.push(2);
            questionArray.push("徳川幕府3代将軍は？\n１、徳川家康\n２、徳川秀忠\n３、徳川家光\n");
            answerArray.push(3);

            questionArray.push("徳川幕府4代将軍は？\n１、徳川綱吉\n２、徳川綱家\n３、徳川家綱\n");
            answerArray.push(3);
            questionArray.push("徳川幕府5代将軍は？\n１、徳川綱吉\n２、生類憐みの令\n３、忠臣蔵\n");
            answerArray.push(1);
            questionArray.push("徳川幕府6代将軍は？\n１、徳川家宣\n２、正徳の治\n３、新井白石\n");
            answerArray.push(1);

            questionArray.push("徳川幕府7代将軍は？\n１、間部詮房\n２、絵島生島事件\n３、徳川家継\n");
            answerArray.push(3);
            questionArray.push("徳川幕府8代将軍は？\n１、暴れん坊将軍\n２、徳川吉宗\n３、マツケンサンバ\n");
            answerArray.push(2);
            questionArray.push("徳川幕府9代将軍は？\n１、徳川家重\n２、骨格女性説\n３、徳川重家\n");
            answerArray.push(1);

            questionArray.push("徳川幕府10代将軍は？\n１、徳川治家\n２、田沼意次\n３、徳川家治\n");
            answerArray.push(3);
            questionArray.push("徳川幕府11代将軍は？\n１、松平定信\n２、徳川家斉\n３、大塩平八郎\n");
            answerArray.push(2);
            questionArray.push("徳川幕府12代将軍は？\n１、徳川家慶\n２、水野忠邦\n３、黒船ペリー\n");
            answerArray.push(1);

            questionArray.push("徳川幕府13代将軍は？\n１、徳川家定\n２、堺雅人\n３、篤姫\n");
            answerArray.push(1);
            questionArray.push("徳川幕府14代将軍は？\n１、勝海舟\n２、松田翔太\n３、徳川家茂\n");
            answerArray.push(2);
            questionArray.push("徳川幕府15代将軍は？\n１、西郷隆盛\n２、大久保利通\n３、徳川慶喜\n");
            answerArray.push(3);
            
            //問題文表示用のテキストを設定
            question = new TextField;
            question.text = "";
            question.x = 10;
            question.y = 10;
            question.width = 300;
            question.height = 170;
            question.multiline = true;
            addChild(question); 

            initQuestion();//問題を初期化

            //解答判定文表示用のテキストを設定
            judge = new TextField;
            judge.x = 55;
            judge.y = 170;
            judge.width = 400;
            judge.height = 200;
            judge.multiline = true;
            judge.text = "";           
            addChild(judge);  
                      
            //解答ボタン設定
            button01 = new CustomButton("１",1);
            button01.x = 350;
            button01.y = 50;
            button02 = new CustomButton("２",2);
            button02.x = 350;
            button02.y = 80;
            button03 = new CustomButton("３",3);
            button03.x = 350;
            button03.y = 110;

            button01.addEventListener(MouseEvent.MOUSE_DOWN,onMouseDown);
            button02.addEventListener(MouseEvent.MOUSE_DOWN,onMouseDown);
            button03.addEventListener(MouseEvent.MOUSE_DOWN,onMouseDown);
            
            button01.addEventListener(MouseEvent.MOUSE_UP,onMouseUp);
            button02.addEventListener(MouseEvent.MOUSE_UP,onMouseUp);
            button03.addEventListener(MouseEvent.MOUSE_UP,onMouseUp);
            
            addChild(button01);
            addChild(button02);
            addChild(button03);
            
            //「次の問題へ」ボタン設定
            nextBtn = new CustomButton("次の問題へ",1);
            nextBtn.x = 350;
            nextBtn.y = 150;
            nextBtn.addEventListener(MouseEvent.MOUSE_DOWN,onNextBtnDown);
            addChild(nextBtn);
        }

        //配列から問題を取り出して問題を初期化
        private function initQuestion():void {
            //問題文テキスト設定
            question.text = "問題　" + (questionNo+1) + "\n"
                          + "\n" 
                          + questionArray[questionNo];
            //問題文テキスト用フォーマット設定
            questionFormat = new TextFormat();
            questionFormat.font = "Courier New";
            questionFormat.bold = true;
            questionFormat.size = 13;
            question.setTextFormat(questionFormat);

            atariLock = false;//次問題のために当たり回数カウントアップができるようにする
        }

        //マウスダウンイベントの処理
        private function onMouseDown(evt:MouseEvent):void {
            if (questionNo > (questionArray.length-1)) return;//全問終了後は処理を行わない
            target = CustomButton(evt.currentTarget);
            //当たりボタンは1問につき1回しかカウントされない
            if (target.getBtnNo() == answerArray[questionNo]) {
                judge.text = "当たり";
                if (atariLock == false) {//同一問題の「当たり」ボタン連続押下時の当たり回数カウントアップを禁止
                    answerCnt++;//解答回数をカウントアップ
                    atariCnt++;//当たり回数をカウントアップ
                    atariLock = true;
                }
            //ハズレボタンは何度でもカウントされる
            } else {
                answerCnt++;//解答回数をカウントアップ
                judge.text = "ハズレ";
                hazureCnt++;//ハズレ回数をカウントアップ
            }
            //判定文テキスト用フォーマット設定
            judgeFormat = new TextFormat();
            judgeFormat.font = "Courier New";
            judgeFormat.bold = true;
            judgeFormat.size = 150;
            judge.setTextFormat(judgeFormat);
        }

        //「次の問題へ」ボタンのマウスダウンイベントの処理
        private function onNextBtnDown(evt:MouseEvent):void {
            if (questionNo < (questionArray.length-1)) {
                questionNo++; //次問題へ遷移するためにカウントアップ
                question.text = "";
                judge.text = "";
                initQuestion();            
            } else {
                questionNo++; //終了処理のためにカウントアップ
                question.text = "";
                endQuestion();
            }
        }

        //マウスアップイベントの処理
        private function onMouseUp(evt:MouseEvent):void {
            //judge.text = "";
        } 

        //全問終了後の処理
        private function endQuestion():void {
            //全問終了後メッセージ設定
            
            //正答率を計算
            var rate : int = 0;
            if ((answerCnt != 0) && (atariCnt != 0)) {//解答回数と当たり回数がどちらも0でない場合のみ計算
                rate = atariCnt/answerCnt*100;
            }

            question.text = "\n解答結果\n\n"//問題文テキストへ解答結果を設定
                          + "解答回数：　" + answerCnt + "回\n"
                          + "当たり回数：　" + atariCnt + "回\n"
                          + "ハズレ回数：　" + hazureCnt + "回\n"
                          + "正答率：　" + rate + "％\n";
            //問題文テキスト用フォーマット設定
            questionFormat = new TextFormat();
            questionFormat.font = "Courier New";
            questionFormat.bold = true;
            questionFormat.size = 13;
            question.setTextFormat(questionFormat);

            judge.text = "クイズ終了です\nお疲れ様でした\n";//判定文テキストへ設定
            //判定文テキスト用フォーマット設定
            judgeFormat = new TextFormat();
            judgeFormat.font = "Courier New";
            judgeFormat.bold = true;
            judgeFormat.size = 50;
            judge.setTextFormat(judgeFormat);
        }       
    }
}

import flash.display.*;
import flash.system.*;
import flash.text.*;
//カスタムボタン
class CustomButton extends SimpleButton {
        private var btnName : String = "";//ボタン名
        private var btnNo : int = 0;//ボタン番号
        //コンストラクタ    
        public function CustomButton(label:String="",no:int=0) {
            btnName = label;
            btnNo = no;
            //状態
            upState = makeSprite(label,0x00FF00);
            overState = upState;
            downState = makeSprite(label,0x0000FF);
            hitTestState = upState;
        }
        
        public function getBtnName():String {
            return btnName;
        }
        public function getBtnNo():int {
            return btnNo;
        }
                
        //ボタン用スプライト作成
        private function makeSprite(text:String,color:uint):Sprite{
            //ボタン用ラベル作成
            var label : TextField = new TextField();
            label.text = text;
            label.autoSize = TextFieldAutoSize.CENTER;
            label.selectable = false;

            //ボタン用スプライト作成
            var sp:Sprite = new Sprite();
            sp.graphics.beginFill(color);
            sp.graphics.drawRoundRect(0, 0, 100, 20, 15);
            sp.graphics.endFill();
            sp.alpha = 0.8;            
            sp.addChild(label);
            
            //ラベル用フォーマット設定
            var format:TextFormat=new TextFormat();
            format.font = "Courier New";
            format.bold = true;
            format.size = 13;
            label.setTextFormat(format);

            return sp;
        }    
}



